#version 430 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 textCoords;
layout (location = 3) in vec3 tangent;
layout (location = 4) in vec3 bitangent;
layout (location = 5) in vec3 position_next;
layout (location = 6) in vec3 normal_next;

out vec3 Positions;
out vec3 Normals;
out vec2 TexCoords;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
uniform float tweenFactor;

void main()
{
	Positions = position * (1.0f - tweenFactor) + position_next * tweenFactor;
	Normals =  normal * (1.0f - tweenFactor) + normal_next * tweenFactor;
    Normals = normalize(vec3(transpose(inverse(modelMatrix)) * vec4(Normals, 0)));
    TexCoords = textCoords;    
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(Positions, 1.0);
}
