#version 430 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 5) in vec3 position_next;
layout (location = 6) in vec3 normal_next;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

uniform float offset = 0.1;
uniform float tweenFactor;

out vec3 Positions;
out vec3 Normals;

void main()
{
	Positions = position * (1.0f - tweenFactor) + position_next * tweenFactor;
	Normals =  normal * (1.0f - tweenFactor) + normal_next * tweenFactor;
	vec4 newPos = vec4(Positions + (Normals * offset), 1.0);
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * newPos;
}
