#version 430
in vec2 TexCoords;

out vec4 gl_FragColor;

uniform sampler2D screenTexture;

mat3 sobel_x = mat3( 
     1.0, 0.0, -1.0, 
     2.0, 0.0, -2.0, 
     1.0, 0.0, -1.0
);

mat3 sobel_y = mat3( 
     1.0,  2.0,  1.0, 
     0.0,  0.0,  0.0, 
    -1.0, -2.0, -1.0
);

void main()
{
	float x = 1.0/1280.0;					// 1 / width
	float y = 1.0/768.0;					// 1 / height
		
	vec4 horizontal = vec4(0.0);
	vec4 vertical = vec4(0.0);

	horizontal += texture2D(screenTexture, vec2(TexCoords.x - x, TexCoords.y + y)) * sobel_x[0][0];
	horizontal += texture2D(screenTexture, vec2(TexCoords.x - x, TexCoords.y    )) * sobel_x[0][1];
	horizontal += texture2D(screenTexture, vec2(TexCoords.x - x, TexCoords.y - y)) * sobel_x[0][2];
	horizontal += texture2D(screenTexture, vec2(TexCoords.x + x, TexCoords.y + y)) * sobel_x[2][0];
	horizontal += texture2D(screenTexture, vec2(TexCoords.x + x, TexCoords.y    )) * sobel_x[2][1];
	horizontal += texture2D(screenTexture, vec2(TexCoords.x + x, TexCoords.y - y)) * sobel_x[2][2];

	vertical += texture2D(screenTexture, vec2(TexCoords.x - x, TexCoords.y + y)) * sobel_y[0][0];
	vertical += texture2D(screenTexture, vec2(TexCoords.x,     TexCoords.y + y)) * sobel_y[1][0];
	vertical += texture2D(screenTexture, vec2(TexCoords.x + x, TexCoords.y + y)) * sobel_y[2][0];
	vertical += texture2D(screenTexture, vec2(TexCoords.x - x, TexCoords.y - y)) * sobel_y[0][2];
	vertical += texture2D(screenTexture, vec2(TexCoords.x    , TexCoords.y - y)) * sobel_y[1][2];
	vertical += texture2D(screenTexture, vec2(TexCoords.x + x, TexCoords.y - y)) * sobel_y[2][2];

	vec3 sobel_edge = sqrt((horizontal.rgb * horizontal.rgb) + (vertical.rgb * vertical.rgb));
	
	vec3 diffuse = texture(screenTexture, TexCoords.st).rgb;
	gl_FragColor = vec4(diffuse - sobel_edge, 1.0);
}
