#version 430 core
layout (location = 0) in vec3 aPos;

out vec4 ParticleColor;

uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
uniform vec3 offset;
uniform vec4 color;

void main()
{
	vec3 camRight = vec3(viewMatrix[0][0], viewMatrix[1][0], viewMatrix[2][0]);
	vec3 camUp = vec3(viewMatrix[0][1], viewMatrix[1][1], viewMatrix[2][1]);
	mat4 VP = projectionMatrix * viewMatrix;

    float scale = 0.03f;
    ParticleColor = color;

	vec3 vertexPosition = offset + camRight * aPos.x * scale + camUp * aPos.y * scale;

	gl_Position = VP * vec4(vertexPosition, 1.0f);
}
